import {
  select,
  classed,
  json,
  tsv,
  geoPath,
  geoNaturalEarth1,
  zoom,
  event
} from 'd3';
import { feature } from 'topojson';

const svg = select('svg');

const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);


const g = svg.append('g')
			 .attr("id", "map");

g.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}))
	;
let selectcountry = null;

const onClick = id =>{
  selectcountry = id
  render()
};

const render = () =>{
	svg, {onClick, selectcountry}
    
}

svg.call(zoom().on('zoom', () => {
  g.attr('transform', event.transform);
}));

Promise.all([
  tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
  json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')
]).then(([tsvData, topoJSONdata]) => {
  
  const countryName = tsvData.reduce((accumulator, d) => {
    accumulator[d.iso_n3] = d.name;
    return accumulator;
  }, {});
  
  /*
  const countryName = {};
  tsvData.forEach(d => {
    countryName[d.iso_n3] = d.name;
  });
  */
  
  
  const countries = feature(topoJSONdata, topoJSONdata.objects.countries);
  g.selectAll('path').data(countries.features)
    .enter().append('path')
    
      .attr('class', 'country')
      .attr('d', pathGenerator)
      .attr("id", function(d, i) {
      return "country" + d.properties.iso_a3;
   })
      .attr("class", "country")
      //.attr('stroke-width', 10)
      //.attr('stroke', d => d.id === selectcountry
            //?'red'
            //:'none')
  	  //.on('click', d => onClick(d.id))
      .on("click", onClick(d.id) {
        d3.selectAll('.country').classed("country-on", false);
        d3.select(d.id).classed("country-on", true);
        
   })

    .append('title')
      .text(d => countryName[d.id]);
  
});